MODULE VorNachfolger EXPORTS Main;
(* Dieses Programm liefert zu einem Zeichen den Vorgnger und den Nachfolger
   Autor    : Horst Lichter
   Umgebung : SRC-Modula-3 rel. 3.6, Windows NT 4.0
   Erstellt : 25.08.98   
   Letzte Aenderung: 25.08.98
*)

IMPORT SIO, Text;

PROCEDURE Offset (): INTEGER =
(*Berechnet die Differenz zwischen den Ordnungszahlen *)
BEGIN
  RETURN (ORD('A') - ORD('a'));
END Offset;

PROCEDURE GrossB(c : CHAR) : CHAR =
(*wandelt Klein in Grossbuchstaben, indem der wert von 
  Offset zur Ordnungszahl hinzu addiert wird *)
BEGIN
  RETURN ( VAL(ORD(c) + Offset(), CHAR) );
END GrossB;

PROCEDURE Vorgaenger (c : CHAR) : CHAR =
(*liefert den Character mit der nchst kleineren Ordnungszahl*)
BEGIN
  RETURN (VAL(ORD(c)-1, CHAR));
END Vorgaenger;

PROCEDURE Nachfolger (c : CHAR) : CHAR =
(*liefert den Character mit der nchst grsseren Ordnungszahl*)
BEGIN
  RETURN (VAL(ORD(c)+1, CHAR));
END Nachfolger;

PROCEDURE Konkat (c, d : CHAR) : TEXT =
(*Verbindet die Rckgabewerte der Funktionen zu einem Text und gibt ihn aus*)
BEGIN
  RETURN (Text.FromChar(c) & Text.FromChar(d));
END Konkat;
 
BEGIN
  (* VorNachfolger = GrossB   o   [ Vorgnger, Nachfolger ]   o   Konkat*)
  SIO.PutText ( Konkat( Vorgaenger( GrossB( SIO.GetChar() )) ,
                        Nachfolger( GrossB( SIO.GetChar() ))
                    )
             );
END VorNachfolger.